<?php
/**
 * InlineObject26
 *
 * PHP version 7.3
 *
 * @category Class
 * @package  SLIS\Adapter\Tanss
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */

/**
 * TANSS API
 *
 * ## Documentation of the TANSS API. Version: 5.8.22.1  ### older versions Older versions of the API documentation can be found here: * [Docs for 5.8.21.6](https://api-doc.tanss.de/5.8.21.6/) * [Docs for 5.8.21.3](https://api-doc.tanss.de/5.8.21.3/) * [Docs for 5.8.21.1](https://api-doc.tanss.de/5.8.21.1/) * [Docs for 5.8.20.5](https://api-doc.tanss.de/5.8.20.5/) * [Docs for 5.8.20.4](https://api-doc.tanss.de/5.8.20.4/) * [Docs for 5.8.20.2](https://api-doc.tanss.de/5.8.20.2/) * [Docs for 5.8.19.3](https://api-doc.tanss.de/5.8.19.3/)
 *
 * The version of the OpenAPI document: 5.8.22.1
 * Contact: support@tanss.de
 * Generated by: https://openapi-generator.tech
 * OpenAPI Generator version: 6.0.0-SNAPSHOT
 */

/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

namespace SLIS\Adapter\Tanss\Model;

use \ArrayAccess;
use \SLIS\Adapter\Tanss\ObjectSerializer;

/**
 * InlineObject26 Class Doc Comment
 *
 * @category Class
 * @description infos required for checking an item in a checklist
 * @package  SLIS\Adapter\Tanss
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 * @implements \ArrayAccess<TKey, TValue>
 * @template TKey int|null
 * @template TValue mixed|null
 */
class InlineObject26 implements ModelInterface, ArrayAccess, \JsonSerializable
{
    public const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $openAPIModelName = 'inline_object_26';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPITypes = [
        'itemId' => 'int',
        'checklistId' => 'int',
        'mainChecklistId' => 'int',
        'linkTypeId' => 'int',
        'linkId' => 'int',
        'value' => 'int',
        'multiSelectId' => 'int',
        'vars' => 'array<string,string>'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      * @phpstan-var array<string, string|null>
      * @psalm-var array<string, string|null>
      */
    protected static $openAPIFormats = [
        'itemId' => null,
        'checklistId' => null,
        'mainChecklistId' => null,
        'linkTypeId' => null,
        'linkId' => null,
        'value' => null,
        'multiSelectId' => null,
        'vars' => null
    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPITypes()
    {
        return self::$openAPITypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPIFormats()
    {
        return self::$openAPIFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'itemId' => 'itemId',
        'checklistId' => 'checklistId',
        'mainChecklistId' => 'mainChecklistId',
        'linkTypeId' => 'linkTypeId',
        'linkId' => 'linkId',
        'value' => 'value',
        'multiSelectId' => 'multiSelectId',
        'vars' => 'vars'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'itemId' => 'setItemId',
        'checklistId' => 'setChecklistId',
        'mainChecklistId' => 'setMainChecklistId',
        'linkTypeId' => 'setLinkTypeId',
        'linkId' => 'setLinkId',
        'value' => 'setValue',
        'multiSelectId' => 'setMultiSelectId',
        'vars' => 'setVars'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'itemId' => 'getItemId',
        'checklistId' => 'getChecklistId',
        'mainChecklistId' => 'getMainChecklistId',
        'linkTypeId' => 'getLinkTypeId',
        'linkId' => 'getLinkId',
        'value' => 'getValue',
        'multiSelectId' => 'getMultiSelectId',
        'vars' => 'getVars'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$openAPIModelName;
    }


    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['itemId'] = $data['itemId'] ?? null;
        $this->container['checklistId'] = $data['checklistId'] ?? null;
        $this->container['mainChecklistId'] = $data['mainChecklistId'] ?? null;
        $this->container['linkTypeId'] = $data['linkTypeId'] ?? null;
        $this->container['linkId'] = $data['linkId'] ?? null;
        $this->container['value'] = $data['value'] ?? null;
        $this->container['multiSelectId'] = $data['multiSelectId'] ?? null;
        $this->container['vars'] = $data['vars'] ?? null;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets itemId
     *
     * @return int|null
     */
    public function getItemId()
    {
        return $this->container['itemId'];
    }

    /**
     * Sets itemId
     *
     * @param int|null $itemId id of the checlist item that will be checked
     *
     * @return self
     */
    public function setItemId($itemId)
    {
        $this->container['itemId'] = $itemId;

        return $this;
    }

    /**
     * Gets checklistId
     *
     * @return int|null
     */
    public function getChecklistId()
    {
        return $this->container['checklistId'];
    }

    /**
     * Sets checklistId
     *
     * @param int|null $checklistId id of the checklist which this item is in
     *
     * @return self
     */
    public function setChecklistId($checklistId)
    {
        $this->container['checklistId'] = $checklistId;

        return $this;
    }

    /**
     * Gets mainChecklistId
     *
     * @return int|null
     */
    public function getMainChecklistId()
    {
        return $this->container['mainChecklistId'];
    }

    /**
     * Sets mainChecklistId
     *
     * @param int|null $mainChecklistId if the item is part of an \"included\" checklist, you must specify the \"main\" checklist as well
     *
     * @return self
     */
    public function setMainChecklistId($mainChecklistId)
    {
        $this->container['mainChecklistId'] = $mainChecklistId;

        return $this;
    }

    /**
     * Gets linkTypeId
     *
     * @return int|null
     */
    public function getLinkTypeId()
    {
        return $this->container['linkTypeId'];
    }

    /**
     * Sets linkTypeId
     *
     * @param int|null $linkTypeId linktype of the assignment (i.e. 11 for ticket)
     *
     * @return self
     */
    public function setLinkTypeId($linkTypeId)
    {
        $this->container['linkTypeId'] = $linkTypeId;

        return $this;
    }

    /**
     * Gets linkId
     *
     * @return int|null
     */
    public function getLinkId()
    {
        return $this->container['linkId'];
    }

    /**
     * Sets linkId
     *
     * @param int|null $linkId link id of the assignment (if assigned to a ticket then the ticket id goes here)
     *
     * @return self
     */
    public function setLinkId($linkId)
    {
        $this->container['linkId'] = $linkId;

        return $this;
    }

    /**
     * Gets value
     *
     * @return int|null
     */
    public function getValue()
    {
        return $this->container['value'];
    }

    /**
     * Sets value
     *
     * @param int|null $value 1 = check / 0 = uncheck
     *
     * @return self
     */
    public function setValue($value)
    {
        $this->container['value'] = $value;

        return $this;
    }

    /**
     * Gets multiSelectId
     *
     * @return int|null
     */
    public function getMultiSelectId()
    {
        return $this->container['multiSelectId'];
    }

    /**
     * Sets multiSelectId
     *
     * @param int|null $multiSelectId if an multiselect option is checked, give the multiselect option id here
     *
     * @return self
     */
    public function setMultiSelectId($multiSelectId)
    {
        $this->container['multiSelectId'] = $multiSelectId;

        return $this;
    }

    /**
     * Gets vars
     *
     * @return array<string,string>|null
     */
    public function getVars()
    {
        return $this->container['vars'];
    }

    /**
     * Sets vars
     *
     * @param array<string,string>|null $vars if vars are needed for checking this field, then give these here
     *
     * @return self
     */
    public function setVars($vars)
    {
        $this->container['vars'] = $vars;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset): bool
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed|null
     */
    #[\ReturnTypeWillChange]
    public function offsetGet($offset)
    {
        return $this->container[$offset] ?? null;
    }

    /**
     * Sets value based on offset.
     *
     * @param int|null $offset Offset
     * @param mixed    $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value): void
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset): void
    {
        unset($this->container[$offset]);
    }

    /**
     * Serializes the object to a value that can be serialized natively by json_encode().
     * @link https://www.php.net/manual/en/jsonserializable.jsonserialize.php
     *
     * @return mixed Returns data which can be serialized by json_encode(), which is a value
     * of any type other than a resource.
     */
    #[\ReturnTypeWillChange]
    public function jsonSerialize()
    {
       return ObjectSerializer::sanitizeForSerialization($this);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        return json_encode(
            ObjectSerializer::sanitizeForSerialization($this),
            JSON_PRETTY_PRINT
        );
    }

    /**
     * Gets a header-safe presentation of the object
     *
     * @return string
     */
    public function toHeaderValue()
    {
        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}


